#include <EEPROM.h>
#include "etherShield.h"
#include "stdio.h"
#include <avr/sleep.h>
#include <avr/power.h>
#include "avr/wdt.h" // include the watchdog library to reboot the Arduino
#include <OneWire.h>
#include <DallasTemperature.h>

// please modify the following two lines. mac and ip have to be unique
// in your local area network. You can not have the same numbers in
// two devices:
static uint8_t mymac[6] = {0x54,0x55,0x58,0x10,0x0A,0x24}; 
static uint8_t myip[4] = {192,168,5,67};
static char baseurl[]="http://192.168.5.67/";
static uint16_t mywwwport =80; 			// listen port for tcp/www (max range 1-254)

#define BUFFER_SIZE 765
static uint8_t buf[BUFFER_SIZE+1];
#define STR_BUFFER_SIZE 32
static char strbuf[STR_BUFFER_SIZE+1];

// !!!  pin4 - SD card slot  !!!!
// ENC28J6 занимает D2, D4, D10, D11, D12, D13
EtherShield es=EtherShield();

// prepare the webpage by writing the data to the tcp send buffer
uint16_t print_webpage(uint8_t *buf);
int8_t analyse_cmd(char *str);

// temperature data pin
// #define TEMP_PIN  7
// OneWire  ds(6);  // on pin 10 (a 4.7K resistor is necessary)

// Data wire is plugged into port 2 on the Arduino
#define ONE_WIRE_BUS 7
#define TEMPERATURE_PRECISION 9

// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);

// Pass our oneWire reference to Dallas Temperature. 
DallasTemperature sensors(&oneWire);

// arrays to hold 1-wire device addresses
DeviceAddress Thermometer[5];

// count of devices
uint8_t SensorCount = 0;
// uint8_t DS1_Address[8];
// uint8_t DS2_Address[8];
float DS_data[5];



// N-Mosfet Gate pin
#define MF1_PIN   5

/*
 This example code is in the public domain.
 aost
*/

// #define RLED       13    // select the pin for the LED
#define sensorPin0 A3    // select the input pin for the potentiometer
#define sensorPin1 A1    // select the input pin for the potentiometer
#define sensorPin2 A2    // select the input pin for the potentiometer

float sensor_0Value = 0;  // variable to store the value coming from the sensor
float sensor_1Value = 0;  // variable to store the value coming from the sensor
float sensor_2Value = 0;  // variable to store the value coming from the sensor
// float sensor_3Value = 512;  // variable to store the value coming from the sensor

float sensor_5_Value[6] = {0,0,0,0,0,0};  // collect 5min average
float     dac_div = 1;

char temp_string[10];

// store data every 5 minute
// timeout data asquisition 1 min
const unsigned int TIME_OFF_SENSOR = 10000; // millis() in the future
const unsigned long TIME_OFF_5min = 300000; // millis() in the future
const unsigned long TIME_OFF_MOSFET = 900000; // millis() in the future
/* 
 Если брать число замеров кратное "4 в степени х" (4, 16, 64, 256...), то вместе 
 с усреднением можно получить и увеличение разрядности АЦП, а следовательно, точности, 
 если "недосдвинуть" полученную сумму вправо. Так, если сдвинуть переменную не на 4, а на 3, 
 то результатом будет представление среднего от 16 измерений в одиннадцати-битном разрешении. 
 Если сдвинуть только на два, то, соответственно, в двенадцати-битном.
*/
const          byte countValues = 64;       // how many values must be averaged in ohne cycle
const word ZeroLevel = 513;  // correction zero for sensor and AREF value - 1024/2=512

unsigned long Uptime;
unsigned long old_millis = 0;
unsigned long old_millis_5min = 0;
unsigned long TIME_ON = 0;
unsigned long TIME_OFF = 0;

void getCurentTemp( int *sign, int *whole, int *fract);

// ds setup variables for 8 sensors. По-уму надо бы здесь структуру замутить.
  byte i;
  byte j = 0;
  byte present = 0;
  byte type_s;
  byte data[12];
  byte addr[8];
  byte found[8][8];
  float celsius[8];
  uint8_t count = 0;

//
// Структура "датчик"
//
struct MySensor {
  byte present = 0;
  byte type_s;    // тип датчика: аналоговый, цифровой, i2c и т.п.
//  byte data[12];  // последние данные, полученные при опросе
  byte addr[8];   // адрес датчика (для DS18B20 с его 8 байтами)
  float celsius[8]; // обработанное значение
  uint8_t count = 0;
};
//
// MySensor sensor[4]; //Десять элементов типа MySensor
//

// function to print a device address
void printAddress(DeviceAddress deviceAddress)
{
  for (uint8_t i = 0; i < 8; i++)
  {
    // zero pad the address if necessary
    if (deviceAddress[i] < 16) Serial.print("0");
    Serial.print(deviceAddress[i], HEX);
  }
}

// function to print the temperature for a device
void printTemperature(DeviceAddress deviceAddress)
{
  float tempC = sensors.getTempC(deviceAddress);
  Serial.print(F(" Temp C: "));
  Serial.print(tempC);
  // Serial.print(" Temp F: ");
  // Serial.print(DallasTemperature::toFahrenheit(tempC));
}

// function to print a device's resolution
void printResolution(DeviceAddress deviceAddress)
{
  Serial.print(F("Resolution: "));
  Serial.print(sensors.getResolution(deviceAddress));
  Serial.println(F(" "));    
}

// main function to print information about a device
void printData(DeviceAddress deviceAddress)
{
  Serial.print(F("Device Address: "));
  printAddress(deviceAddress);
  Serial.print(F(" "));
  printTemperature(deviceAddress);
  Serial.println();
}


/*
Calculate value from sensor
*/
float getSensorValue( int sensorPin, float dac_div = 1 ) // Value from sensor
{
  static float sensorValue = 0;  // variable to store the value coming from the sensor
  static int reperValue = 0;

  analogRead(sensorPin);

  for (int count =0; count < 16; count++) {

    reperValue += constrain(analogRead(sensorPin),0,1023);
    delay(3);

  }
    // усредняем значения эталона
    // reperValue =  reperValue / 10;
    reperValue = reperValue >> 4;
    // устанавливаем границы допустимых значений
    int reperValue_max = reperValue + 20;
    int reperValue_min = reperValue - 20;

    // main routine
  for (int count =0; count < countValues; count++) {

    // read the value from the sensor:
    static float TMPsensorValue = constrain(analogRead(sensorPin),0,1023);
    delay(3);

    // detect the maximum sensor value
    // select the minimum sensor value
    if (TMPsensorValue >= reperValue_max || TMPsensorValue <= reperValue_min) { 
       TMPsensorValue = reperValue; 
     }
    // if the value between +-25 - set the new reper and recalculate min-max
    else { 
       reperValue = TMPsensorValue;
       reperValue_max = reperValue + 25;
       reperValue_min = reperValue - 25;
      }
    // summarize
    sensorValue = ( sensorValue + TMPsensorValue );
   }
    // усредняем значения
    sensorValue = dac_div * sensorValue / countValues;
    return sensorValue;
  }

// Function

long vccRead() {
  // Read 1.1V reference against AVcc
  // set the reference to Vcc and the measurement to the internal 1.1V reference
  #if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
    ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  //#elif defined (__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__)
  //  ADMUX = _BV(MUX5) | _BV(MUX0);
  //#elif defined (__AVR_ATtiny25__) || defined(__AVR_ATtiny45__) || defined(__AVR_ATtiny85__)
  //  ADMUX = _BV(MUX3) | _BV(MUX2);
  #else
    ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #endif  
 
  delay(60); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Start conversion
  while (bit_is_set(ADCSRA,ADSC)); // measuring
 
  uint8_t low  = ADCL; // must read ADCL first - it then locks ADCH  
  uint8_t high = ADCH; // unlocks both
 
  long result = (high<<8) | low;
 
  result = 1125300L / result; // Calculate Vcc (in mV); 1125300 = 1.1*1023*1000
  return result; // Vcc in millivolts
}

// function Temperature
/*
void getDSTemp( void ) {
  
  for(j=0; j < count; j++) {

  ds.reset();
  ds.select(found[j]);
  ds.write(0x44, 1);        // start conversion, with parasite power on at the end
  delay(800);     // maybe 750ms is enough, maybe not
  // we might do a ds.depower() here, but the reset will take care of it.
  
  present = ds.reset();
  ds.select(found[j]);
  ds.write(0xBE);         // Read Scratchpad

  // Serial.print(F("\r\n  Data = "));
  // Serial.print(present, HEX);
  // Serial.print(" ");
  for ( i = 0; i < 9; i++) {           // we need 9 bytes
      data[i] = ds.read();
  //  Serial.print(data[i], HEX);
  //  Serial.print(" ");
  }
  // Serial.print(" CRC=");
  // Serial.print(OneWire::crc8(data, 8), HEX);
  // Serial.println();

  // Convert the data to actual temperature
  // because the result is a 16 bit signed integer, it should
  // be stored to an "int16_t" type, which is always 16 bits
  // even when compiled on a 32 bit processor.
  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) {
    raw = raw << 3; // 9 bit resolution default
    if (data[7] == 0x10) {
      // "count remain" gives full 12 bit resolution
      raw = (raw & 0xFFF0) + 12 - data[6];
    }
  } else {
    byte cfg = (data[4] & 0x60);
    // at lower res, the low bits are undefined, so let's zero them
    if (cfg == 0x00) raw = raw & ~7;  // 9 bit resolution, 93.75 ms
    else if (cfg == 0x20) raw = raw & ~3; // 10 bit res, 187.5 ms
    else if (cfg == 0x40) raw = raw & ~1; // 11 bit res, 375 ms
    //// default is 12 bit resolution, 750 ms conversion time
  }
  celsius[j] = (float)raw / 16.0;
  //fahrenheit = celsius * 1.8 + 32.0;
  // Serial.print("  Temperature = ");
  // Serial.print(celsius[j]);
  // Serial.print(" Celsius, ");
      
    }
        // char temp
	//sprintf(temp, "%c%3d%c%0.2d", (sign==0)?'+':'-', whole, '.', fract);
  } // end function
*/



void setup(){
   /* Disable watchdog timer */
        wdt_disable();

  	/* Disable SD card */
  	pinMode(4, OUTPUT);
  	digitalWrite(4, HIGH);
  	  
   	/*initialize enc28j60*/
  	es.ES_enc28j60Init(mymac);
   	es.ES_enc28j60clkout(2); // change clkout from 6.25MHz to 12.5MHz
   	delay(10);
        
	/* Magjack leds configuration, see enc28j60 datasheet, page 11 */
   // LEDA=greed LEDB=yellow
	 //
	 // 0x880 is PHLCON LEDB=on, LEDA=on
	 // enc28j60PhyWrite(PHLCON,0b0000 1000 1000 00 00);
	 es.ES_enc28j60PhyWrite(PHLCON,0x880);
	 delay(500);
	 //
	 // 0x990 is PHLCON LEDB=off, LEDA=off
	 // enc28j60PhyWrite(PHLCON,0b0000 1001 1001 00 00);
	 es.ES_enc28j60PhyWrite(PHLCON,0x990);
	 delay(500);
	 //
	 // 0x880 is PHLCON LEDB=on, LEDA=on
	 // enc28j60PhyWrite(PHLCON,0b0000 1000 1000 00 00);
	 es.ES_enc28j60PhyWrite(PHLCON,0x880);
	 delay(500);
	 //
	 // 0x990 is PHLCON LEDB=off, LEDA=off
	 // enc28j60PhyWrite(PHLCON,0b0000 1001 1001 00 00);
	 es.ES_enc28j60PhyWrite(PHLCON,0x990);
	 delay(500);
	 //
   // 0x476 is PHLCON LEDA=links status, LEDB=receive/transmit
   // enc28j60PhyWrite(PHLCON,0b0000 0100 0111 01 10);
   es.ES_enc28j60PhyWrite(PHLCON,0x476);
	 delay(100);
        
   //init the ethernet/ip layer:
   es.ES_init_ip_arp_udp_tcp(mymac,myip,mywwwport);

    // serial output
    Serial.begin(9600);
    Serial.println( F("\n\rSketch \"etherShield Web\" was loaded at " __DATE__));

    Serial.print( F("IP address= " )); 

    for(i=0; i<3; i++) {

       Serial.print( myip[i]);
       Serial.print( F("."));

        }
    Serial.print( myip[i]);
    Serial.println(F(";"));
    
    //Serial.print( F("revision " )); Serial.println( Revision );
    Serial.println( F("Read data from sensors ..." )); 

    //
    //   initialize DS18B20 datapin
    //   Start up the 1-wire library
    sensors.begin();   

    // locate devices on the bus
    SensorCount = sensors.getDeviceCount();
    // eeprom_write_byte(&SensorCount,SensorCount);
    Serial.print(F("Locating devices..."));
    Serial.print(F(" We found "));
    // Serial.print(eeprom_read_byte(&SensorCount), DEC);
    Serial.print( SensorCount, DEC);
    Serial.println(F(" devices."));

     // method 2: search()
     // Must be called before search()
     oneWire.reset_search();

     sensors.requestTemperatures();
     // show the addresses we found on the bus
     for(int i=0; i < SensorCount; i++){
        if (!oneWire.search(Thermometer[i])) Serial.print(F("Unable to find address for insideThermometer"));
        Serial.print(F("Device Address: "));
        printAddress(Thermometer[i]);

       // set the resolution to 9 bit per device
       // sensors.setResolution(Thermometer[i], TEMPERATURE_PRECISION);
       Serial.print(F(" Device ")); Serial.print( i ); Serial.print(F(" Resolution: "));
       Serial.print(sensors.getResolution(Thermometer[i]), DEC); 
       Serial.print(F(" ; Temperature= "));
       // print the device information

        DS_data[i] = sensors.getTempC(Thermometer[i]);
        Serial.print(DS_data[i]);

       // printTemperature(Thermometer[i]);
       Serial.println(F(" "));

  } // end of "for ... sensor count"


    // N-Mosfet
    pinMode(MF1_PIN, OUTPUT);      // sets the digital pin as input (logic 1)
    digitalWrite(MF1_PIN, LOW);

    // amperage data
    analogReference(DEFAULT);

    // pin mode for sensors

    pinMode(sensorPin0, INPUT); // Curent sensor
    digitalWrite(sensorPin0, LOW); //internal analog input pullup

    pinMode(sensorPin1, INPUT); // voltmeter1 sensor
    digitalWrite(sensorPin1, LOW);   //

    pinMode(sensorPin2, INPUT); // voltmeter2 sensor
    analogRead(sensorPin2);
    digitalWrite(sensorPin2, LOW);   //
    // delay(10);
    // Serial.print( F("Sensor2 = ")); Serial.println( analogRead( sensorPin2 ));
    // digitalWrite(sensorPin1, HIGH); //internal analog input pullup

    // shift first sensors reading
    old_millis = millis() - 20000;
    // getCurentTemp(temp_string);
    // getDSTemp();

    // read first data from sensors
    sensor_5_Value[0] = getSensorValue(sensorPin0);
    sensor_5_Value[1] = getSensorValue(sensorPin1);
    sensor_5_Value[2] = getSensorValue(sensorPin2);

    wdt_enable(WDTO_8S);
    wdt_reset();  //Good practice to reset the watchdog in setup

} // end of setup()


void loop(){
  /* Reset watchdog timer */
   cli();
   wdt_reset();
   sei();

  /* Collect sensor data */
  if( millis() - old_millis > TIME_OFF_SENSOR ){
    old_millis = millis();

    dac_div = (float)vccRead()/ 5000;

    /* Ampermeter */
    // sensor_0Value = getSensorValue(sensorPin0, dac_div);
    sensor_5_Value[0] = (sensor_5_Value[0] + getSensorValue(sensorPin0, dac_div))/2;

    if (sensor_5_Value[0] - ZeroLevel < 4) { 

      sensor_5_Value[0] = ZeroLevel; 

    }

    // защита от анормально больших значений (выход из строя датчика, например)
    // Sensor0 = 83.00 => 6A принимаем, что максимально может быть 15A => Sensor0 = 203
    if (sensor_5_Value[0] - ZeroLevel > 204) { 

      sensor_5_Value[0] = 204 + ZeroLevel ; 

    }
 
    //Serial.print(F("Amper ")); Serial.print(sensor_0Value); 
    //Serial.print(" Value Amp: "); Serial.println(floor(sensor_5_Value[0]));



    /* Voltmeter1 */
    //sensor_1Value = getSensorValue( sensorPin1, dac_div );
    sensor_5_Value[1] = (sensor_5_Value[1] + getSensorValue( sensorPin1, dac_div ))/2;


    /* Voltmeter2 */
    // sensor_2Value = getSensorValue( sensorPin2, dac_div );
    sensor_5_Value[2] = (sensor_5_Value[2] + getSensorValue( sensorPin2, dac_div ))/2;

    //Serial.print(F("Revision: ")); Serial.print(Revision);
    //Serial.print(F("  DAC 0 value:")); Serial.print(sensor_5_Value[0]); 
    //Serial.print(F("  DAC 1 value:")); Serial.println(sensor_5_Value[1]);

   // Serial.print(millis()); Serial.print("  TIME_ON = "); Serial.print( TIME_ON );
   // Serial.print("    MF1_PIN = "); Serial.println( digitalRead(MF1_PIN) );

    if( millis() - old_millis_5min > TIME_OFF_5min ){
      old_millis_5min = millis();

      /* Temperature */
      getCurentTemp(temp_string);
    /* collect temperature data to array*/
    sensors.requestTemperatures();

    for(int i=0; i < SensorCount; i++){

      DS_data[i] = sensors.getTempC(Thermometer[i]);

      }

      /*                 Mosfet drive                    */

      // Amperage: sensor_5_Value[0]
      // Battery:  sensor_5_Value[1] "???" -> 12.7V  "714"->13.0V   "769" -> 13.58V     "7??" = 14.2V
      // Array:    sensor_5_Value[2] "190" -> 12V      "252" -> 17V       "295" = 20.5V

      //                 digitalRead(MF1_PIN) HIGH

      if( digitalRead(MF1_PIN) == 1 ) {

        // Reset time-out
        if(TIME_OFF == 0) { TIME_OFF = millis(); }

        if( sensor_5_Value[0] < 512 || sensor_5_Value[1] < 710 ) {

          if( millis() - TIME_OFF > TIME_OFF_MOSFET ){

               digitalWrite(MF1_PIN, LOW);
               TIME_ON = 0;

          }

        }
       
      }

      //                 digitalRead(MF1_PIN) LOW

      if( digitalRead(MF1_PIN) == 0 ) {

      //
      // если напряжение на батарее выше 740 единиц, по истечение таймаута включаем grid-tie
      //  if( sensor_5_Value[1] > 735 && sensor_5_Value[0] > 530 ) {
        if( sensor_5_Value[1] > 727 ) {

          // Reset time-out
          if(TIME_ON == 0) { TIME_ON = millis(); }
          
          if( millis() - TIME_ON > TIME_OFF_MOSFET ){

             digitalWrite(MF1_PIN, HIGH);
               TIME_OFF = 0;

          }
       //
       // или, если Array voltage выше 380 - тоже включаем grid-tie
       //
        } else if ( sensor_5_Value[2] > 380 ) {

          // Time-out
          if(TIME_ON == 0) { TIME_ON = millis();  }
          
          if( millis() - TIME_ON > 2 * TIME_OFF_MOSFET ){

             digitalWrite(MF1_PIN, HIGH);
               TIME_OFF = 0;

          }

        }
  // Serial.print(sensor_0Value); Serial.print(" :: sensor1 = "); Serial.print(sensor_1Value); Serial.print(" :: sensor2 = "); Serial.println(sensor_2Value);
  // Serial.print("MF1_PIN = "); Serial.println( digitalRead(MF1_PIN) );
      
      }

    }
  }


/* Work Ethernet Shield */
  uint16_t plen, dat_p;
  int8_t cmd;

  plen = es.ES_enc28j60PacketReceive(BUFFER_SIZE, buf);

	/*plen will ne unequal to zero if there is a valid packet (without crc error) */
  if(plen!=0){
  	           
    // arp is broadcast if unknown but a host may also verify the mac address by sending it to a unicast address.
    if(es.ES_eth_type_is_arp_and_my_ip(buf,plen)){
      es.ES_make_arp_answer_from_request(buf);
      return;
    }

    // check if ip packets are for us:
    if(es.ES_eth_type_is_ip_and_my_ip(buf,plen)==0){
      return;
    }
    
    if(buf[IP_PROTO_P]==IP_PROTO_ICMP_V && buf[ICMP_TYPE_P]==ICMP_TYPE_ECHOREQUEST_V){
      es.ES_make_echo_reply_from_request(buf,plen);
      return;
    }
    
    // tcp port www start, compare only the lower byte
    if (buf[IP_PROTO_P]==IP_PROTO_TCP_V&&buf[TCP_DST_PORT_H_P]==0&&buf[TCP_DST_PORT_L_P]==mywwwport){
      if (buf[TCP_FLAGS_P] & TCP_FLAGS_SYN_V){
         es.ES_make_tcp_synack_from_syn(buf); // make_tcp_synack_from_syn does already send the syn,ack
         return;     
      }
      if (buf[TCP_FLAGS_P] & TCP_FLAGS_ACK_V){
        es.ES_init_len_info(buf); // init some data structures
        dat_p=es.ES_get_tcp_data_pointer();

        if (dat_p==0){ // we can possibly have no data, just ack:
          if (buf[TCP_FLAGS_P] & TCP_FLAGS_FIN_V){
            es.ES_make_tcp_ack_from_any(buf);
          }
          return;
        }

        if (strncmp("GET ",(char *)&(buf[dat_p]),4)!=0){
       	// head, post and other methods for possible status codes see:
        // http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html
            plen=es.ES_fill_tcp_data_p(buf,0,PSTR("HTTP/1.0 200 OK\r\nContent-Type: text/html\r\n\r\n<h1>200 OK</h1>"));
            goto SENDTCP;
        }
       if (strncmp("/ ",(char *)&(buf[dat_p+4]),2)==0){
                plen=print_webpage(buf);
            goto SENDTCP;
         }
        cmd=analyse_cmd((char *)&(buf[dat_p+5]));
        if (cmd==1){
             plen=print_webpage(buf);
        } else if (cmd == 5) {
             digitalWrite(MF1_PIN, HIGH);
             plen=print_webpage(buf);
        } else if (cmd == 6) {
             digitalWrite(MF1_PIN, LOW);
             plen=print_webpage(buf);
        }
        
SENDTCP:  es.ES_make_tcp_ack_from_any(buf); // send ack for http get
           es.ES_make_tcp_ack_with_data(buf,plen); // send data       
      }
    }
  }
        
}

// The returned value is stored in the global var strbuf
uint8_t find_key_val(char *str,char *key)
{
        uint8_t found=0;
        uint8_t i=0;
        char *kp;
        kp=key;
        while(*str &&  *str!=' ' && found==0){
                if (*str == *kp){
                        kp++;
                        if (*kp == '\0'){
                                str++;
                                kp=key;
                                if (*str == '='){
                                        found=1;
                                }
                        }
                }else{
                        kp=key;
                }
                str++;
        }
        if (found==1){
                // copy the value to a buffer and terminate it with '\0'
                while(*str &&  *str!=' ' && *str!='&' && i<STR_BUFFER_SIZE){
                        strbuf[i]=*str;
                        i++;
                        str++;
                }
                strbuf[i]='\0';
        }
        return(found);
}

int8_t analyse_cmd(char *str)
{
        int8_t r=-1;
     
        if (find_key_val(str,"cmd")){
                if (*strbuf < 0x3a && *strbuf > 0x2f){
                        // is a ASCII number, return it
                        r=(*strbuf-0x30);
                }
        }
        return r;
}

uint16_t print_webpage(uint8_t *buf)
{
        uint16_t plen;

     // ******************************************************************* sensor0 Ampermeter
     // 5000 mV = 1023 DAC   sensor = 100 mV/A  result= 5000/(1023*100) = 0.048828125 A
     // int CurrentValue = 488 * ( sensor_5_Value[0] - ZeroLevel );
     // 30A sensor 66 mV/A divider = 739
  
    // int CurrentValue = 488 * ( floor(sensor_5_Value[0]) - ZeroLevel )/10;
   int CurrentValue = 739 * ( floor(sensor_5_Value[0]) - ZeroLevel )/10;
     // reformat float number to string
     // Serial.print(F("sensor_5_value_0 = ")); Serial.println(sensor_5_Value[0]);
     // Serial.print(F("Current Value = ")); Serial.println(CurrentValue);
   char current_value[10];
   dtostrf(CurrentValue, 7, 2, current_value );

   // request data from sensor1
   // sensor_1Value = ( sensor_5_Value[1] * 0.0193 );
   sensor_1Value = ( sensor_5_Value[1] * 0.0184 );
   // sensor_1Value = ( sensor_5_Value[1] * 0.01764 );
   char voltmeter_1value[10];
   dtostrf(sensor_1Value, 7, 2, voltmeter_1value );

   // request data from sensor2
   // sensor_2Value = ( floor(sensor_5_Value[2]) * 0.063 );
   sensor_2Value = ( sensor_5_Value[2] * 0.056 );
   char voltmeter_2value[10];
   dtostrf(sensor_2Value, 7, 2, voltmeter_2value );

   char Debug_char[8];
   dtostrf( ( floor(sensor_5_Value[0]) - ZeroLevel ), 4, 2, Debug_char );

   char Debug0_char[8];
   dtostrf(sensor_5_Value[1], 4, 2, Debug0_char );

   char Debug1_char[8];
   dtostrf(sensor_5_Value[2], 4, 2, Debug1_char );

   char Debug2_char[8];
   dtostrf( dac_div, 4, 2, Debug2_char );

   static char Separator[] = "<br>";
   
   // Serial.print(F("sensor_1 value:")); Serial.println(voltmeter_1Value);
   // Serial.print(F(" :: curent.value = ")); Serial.println(volmeter_1Value);

   // Send uptime to web
   Uptime = millis() / 1000;
   char c_uptime[32];
   // itoa( Uptime, c_uptime, 16);
   dtostrf( Uptime, 26, 0, c_uptime );
   // sprintf( c_uptime, "%u", millis() );

        
        plen=es.ES_fill_tcp_data_p(buf,0,PSTR("HTTP/1.0 200 OK\r\nContent-Type: text/html\r\n\r\n"));
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<html><head><title>Arduino Sensor</title><META HTTP-EQUIV=\"Refresh\" CONTENT=\"600\"></head>"));
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<body><center><h2>enc28j60 Eth-Shield<br>uptime.value "));

        int k = 0;
        while (c_uptime[k]) {
                buf[TCP_CHECKSUM_L_P+3+plen]=c_uptime[k++];
                plen++;
        }
         
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<hr wide=70%><br><form METHOD=get action=\""));
        plen=es.ES_fill_tcp_data(buf,plen,baseurl);
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("\">"));

   // print temperature from sensors

        for (int j=0; j< SensorCount; j++){
        
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br>temperature.value "));

        dtostrf( DS_data[j], 4, 2, temp_string );

        int i=0;
        while (temp_string[i]) {
                buf[TCP_CHECKSUM_L_P+3+plen]=temp_string[i++];
                plen++;
            }

        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("  &#176C<br> ") );

        }
 
      	plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br>sensor.value "));

        // print temperature value
        k = 0;
 	      while (current_value[k]) {
                buf[TCP_CHECKSUM_L_P+3+plen]=current_value[k++];
                plen++;
        }

      	plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" mA<br><b>sensor1.value ") );
 	      plen=es.ES_fill_tcp_data(buf, plen, voltmeter_1value);

      	plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" V<br><b>sensor2.value ") );
 	      plen=es.ES_fill_tcp_data(buf, plen, voltmeter_2value);

        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" V<br><br><input type=hidden name=cmd value=1>"));
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<input type=submit value=\"Get Temperature\"></form>"));

 	      plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br><b>mosfet.value &quot;") );

        char Mosfet[3];
        //dtostrf( digitalRead(MF1_PIN), 3, 0, c_mosfet );
        itoa(digitalRead(MF1_PIN), Mosfet, 2);

      	plen=es.ES_fill_tcp_data(buf, plen, Mosfet);

        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&quot;<br></center><hr wide=80%>"));


        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br>Sensor0 = "));
 	      plen=es.ES_fill_tcp_data(buf, plen, Debug_char);

        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br>Sensor1 = "));
 	      plen=es.ES_fill_tcp_data(buf, plen, Debug0_char);

        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br>Sensor2 = "));
 	      plen=es.ES_fill_tcp_data(buf, plen, Debug1_char);

        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br>DAC div = "));
 	      plen=es.ES_fill_tcp_data(buf, plen, Debug2_char);
 
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br></h2></body></html>"));
  
        return(plen);
}




// ************************* old function *************************
void getCurentTemp(char *temp){
sensors.requestTemperatures();

  // print the device information
  for(int i=0; i < SensorCount; i++){
  // printData(Thermometer[i]);
  //printTemperature(Thermometer[i]);

   DS_data[i] = sensors.getTempC(Thermometer[i]);
  //float tempC = sensors.getTempC(Thermometer[i]);
  // dtostrf( tempC, 4, 2, temp );

  }

} // end function getCurrentTemp()

/*
void OneWireReset(int Pin) // reset.  Should improve to act as a presence pulse
{
     digitalWrite(Pin, LOW);
     pinMode(Pin, OUTPUT); // bring low for 500 us
     // delayMicroseconds(1000);     // maybe 750ms is enough, maybe not
     delayMicroseconds(750);
     pinMode(Pin, INPUT);
     delayMicroseconds(750);
}
*/
/*
void OneWireOutByte(int Pin, byte d) // output byte d (least sig bit first).
{
   byte n;

   for(n=8; n!=0; n--)
   {
      if ((d & 0x01) == 1)  // test least sig bit
      {
         digitalWrite(Pin, LOW);
         pinMode(Pin, OUTPUT);
         delayMicroseconds(5);
         pinMode(Pin, INPUT);
         delayMicroseconds(60);
      }
      else
      {
         digitalWrite(Pin, LOW);
         pinMode(Pin, OUTPUT);
         delayMicroseconds(60);
         pinMode(Pin, INPUT);
      }

      d=d>>1; // now the next bit is in the least sig bit position.
   }
}
*/

/*
byte OneWireInByte(int Pin) // read byte, least sig byte first
{
    byte d, n, b;

    for (n=0; n<8; n++)
    {
        digitalWrite(Pin, LOW);
        pinMode(Pin, OUTPUT);
        delayMicroseconds(5);
        pinMode(Pin, INPUT);
        delayMicroseconds(5);
        b = digitalRead(Pin);
        delayMicroseconds(50);
        d = (d >> 1) | (b<<7); // shift d to right and insert b in most sig bit position
    }
    return(d);
}
*/


/*
void getCurentTemp(char *temp)
{  
  int HighByte, LowByte, TReading, Tc_100, sign, whole, fract;

  OneWireReset(TEMP_PIN);
  OneWireOutByte(TEMP_PIN, 0xcc);
  OneWireOutByte(TEMP_PIN, 0x44); // perform temperature conversion, strong pullup for one sec

  OneWireReset(TEMP_PIN);
  OneWireOutByte(TEMP_PIN, 0xcc);
  OneWireOutByte(TEMP_PIN, 0xbe);

  LowByte = OneWireInByte(TEMP_PIN);
  HighByte = OneWireInByte(TEMP_PIN);
  TReading = (HighByte << 8) + LowByte;
  sign = TReading & 0x8000;  // test most sig bit
  if (sign) // negative
  {
    TReading = (TReading ^ 0xffff) + 1; // 2's comp
  }
  Tc_100 = (6 * TReading) + TReading / 4;    // multiply by (100 * 0.0625) or 6.25

  whole = Tc_100 / 100;  // separate off the whole and fractional portions
  fract = Tc_100 % 100;


	sprintf(temp, "%c%3d%c%0.2d", (sign==0)?'+':'-', whole, '.', fract);
	
}
*/
/*
	if(sign) temp[0]='-';
	else 		 temp[0]='+';
	
	temp[1]= whole%100+'0';
	temp[2]= (whole-100*temp[1])%10 +'0' ;
	temp[3]= whole-100*temp[1]-10*temp[2] +'0';
	
	temp[4]='.';
	temp[5]=fract%10 +'0';
	temp[6]=fract-temp[5]*10 +'0';
	
	temp[7] = '\0';
*/



// ************************************************************
// void EEPROM_float_write(int addr, float val) // запись в ЕЕПРОМ
// {
//  byte *x = (byte *)&val;
//  for(byte i = 0; i < 4; i++) EEPROM.write(i+addr, x[i]);
// }

// float EEPROM_float_read(int addr) // чтение из ЕЕПРОМ
// {
//  byte x[4];
//  for(byte i = 0; i < 4; i++) x[i] = EEPROM.read(i+addr);
//  float *y = (float *)&x;
//  return y[0];
// }
